	org $1001-2
	dw  $1001
	
ptr	= $E0
rows	= $E2
col	= $E3
height	= $E4
dadrLo	= $E5
dadrHi	= $E6

fx_ptr	= $F0	; 16 bit
fx_cnt	= $F2	; 16 bit

bitmap_ptr	= $F4
gfx_ptr		= $F6
bit_cnt		= $F8

color_set	= $C500
raster_call_top = $E100
raster_call_bot = $EF00

	include "music\!playerv.asm"
	
	dw nextln,0	; second word is line number
	db $9e
	if start > 9999
	db "0"+start/10000
	endif
	db "0"+(start/1000)%10,"0"+(start/100)%10,"0"+(start/10)%10,"0"+start%10,0
nextln	db 0,0
 
code_gen2 macro call_dest, ofs, col1, col2, col3
	lda ptr
	sta call_dest+1
	lda ptr+1
	sta call_dest+2
	;
	lda #(raster_call_bot+ofs) & 255
	sta dadr1Lo+1
	lda #(raster_call_bot+ofs) >> 8
	sta dadr1Hi+1
	;
	lda dadrLo
	clc
	adc #ofs
	sta dadr2Lo+1
	lda dadrHi
	adc #$00
	sta dadr2Hi+1
	;
	lda #col1
	sta lum
	lda #col2
	sta lum+1
	lda #col3
	sta lum+2
	;
	jsr codegen2
	;
	endm

;incpos	macro pos
;	lda pos+1
;	clc
;	adc #$01
;	and #$7f
;	sta pos+1
;	endm
	
start
	sei
	sta $ff3f
	;
	lda #5*8
	sta height
	;
	ldx #(raster_call_top+$56*((5*8)-1)) & 255
	ldy #(raster_call_top+$56*((5*8)-1)) >> 8
	;
	lda $FF07
	and #$40
	beq pal
	;
	lda #$F5
	sta ntsc2+1
	;
	lda #2*8
	sta height
	;
	ldx #(raster_call_top+$56*((2*8)-1)) & 255
	ldy #(raster_call_top+$56*((2*8)-1)) >> 8
	;
pal	stx dadrLo
	sty dadrHi
	;
	; ---
	;
	lda #raster_call_top & 255
	sta ptr
	lda #raster_call_top >> 8
	sta ptr+1
	jsr codegen1
	;
	lda #raster_call_bot & 255
	sta ptr
	lda #raster_call_bot >> 8
	sta ptr+1
	jsr codegen1
	;
	lda #color_set & 255
	sta ptr
	lda #color_set >> 8
	sta ptr+1
	;
	;db $B,$2,$8,$9,$7,$A
	code_gen2 call01, $03, colorsB>>8,colorsB>>8,colorsB>>8
	code_gen2 call02, $08, colorsB>>8,colorsB>>8,colors2>>8
	code_gen2 call03, $0D, colorsB>>8,colors2>>8,colors2>>8
	code_gen2 call04, $12, colors2>>8,colors2>>8,colors2>>8
	code_gen2 call05, $17, colors2>>8,colors2>>8,colors8>>8
	code_gen2 call06, $1C, colors2>>8,colors8>>8,colors8>>8
	code_gen2 call07, $21, colors8>>8,colors8>>8,colors8>>8
	code_gen2 call08, $26, colors8>>8,colors8>>8,colors9>>8
	code_gen2 call09, $2B, colors8>>8,colors9>>8,colors9>>8
	code_gen2 call10, $30, colors9>>8,colors9>>8,colors9>>8
	code_gen2 call11, $35, colors9>>8,colors9>>8,colors7>>8
	code_gen2 call12, $3A, colors9>>8,colors7>>8,colors7>>8
	code_gen2 call13, $3F, colors7>>8,colors7>>8,colors7>>8
	code_gen2 call14, $44, colors7>>8,colors7>>8,colorsA>>8
	code_gen2 call15, $49, colors7>>8,colorsA>>8,colorsA>>8
	code_gen2 call16, $01, colorsA>>8,colorsA>>8,colorsA>>8
	;
	; ---
	;
	lda #(fx_data-4) & 255
	sta fx_ptr
	lda #(fx_data-4) >> 8
	sta fx_ptr+1
	lda #$00
	sta fx_cnt
	sta fx_cnt+1
	;
	; ---
	;
	;
	;
	jsr PLAYER_FREQ_INIT
	;
	lda $FF1D
	cmp #$CC
	bne *-5
	;
	lda #$3B	; turn graphics mode on
	sta $FF06
	lda #$12
	sta $FF15
	lda #$00
	sta $FF16
	;
	jmp main
	
	align 256
	;
main	; ---
	;
	bit $24
	;
ntsc2	lda #$0F
	cmp $FF1D
	bne *-3
	;
	lda $FF1E
	;
	cmp #$E2
	beq ah36
	cmp #$E0
	beq ah32
	cmp #$DE
	beq ah28
	cmp #$DC
	beq ah24
	cmp #$DA
	beq ah20
	cmp #$D8
	beq ah16
	cmp #$D6
	beq ah12
	cmp #$D4 
	beq ah08
	cmp #$D2
	beq ah04
	cmp #$D0
	beq ah00
	;
	jmp *
	;
ah36	bit $24
ah32	bit $24
ah28	bit $24
ah24	bit $24
ah20	bit $24
ah16	bit $24
ah12	bit $24
ah08	bit $24
ah04	bit $24
ah00	;
	;
	asl $06
	asl $06
	asl $06
	asl $06
	asl $06
	asl $06
	asl $06
	asl $06
	asl $06
	asl $06
	nop
	;
	ldx #$00
	;
	jsr raster_call_top
	;     
	lda $FF07	; PAL/NTSC friendly
	and #$40
gfx1	ora #$18	; use $18 for multicolor
	sta $FF07
	;
	lda $FF12
	and #$03	; keep lowest 2 bits (sound)	
gfx2	ora #$08	; $08 = $2000, $10 = $4000, etc.
	sta $FF12
	;
gfx3	lda #$18	; color map
	sta $FF14
	;
 	; ---
 	;
	;lda #$53
	;cmp $FF1D
	;bne *-3
	;
	;dec $FF19
	;
	jsr PLAYER
	;
	;inc $FF19
	;
	; ---
	;
	jsr set_colors
	;
	;dec $FF19
	;
	jsr fx
	;
	;inc $FF19
	;
	;lda #$CA
	;cmp $FF1D
	;bne *-3
	;
	lda #$CC
	cmp $FF1D
	bne *-3
	;
sync1	lda $FF1E
;	cmp #$D0
;	bcc sync1	; FF1E will be in $D0-$E0 range
	;
	cmp #$E2
	beq ai36
	cmp #$E0
	beq ai32
	cmp #$DE
	beq ai28
	cmp #$DC
	beq ai24
	cmp #$DA
	beq ai20
	cmp #$D8
	beq ai16
	cmp #$D6
	beq ai12
	cmp #$D4 
	beq ai08
	cmp #$D2
	beq ai04
	cmp #$D0
	beq ai00
	;
	jmp *
	;
ai36	bit $24
ai32	bit $24
ai28	bit $24
ai24	bit $24
ai20	bit $24
ai16	bit $24
ai12	bit $24
ai08	bit $24
ai04	bit $24
ai00	;
	;
	asl $06
	asl $06
	asl $06
	asl $06
	asl $06
	asl $06
	asl $06
	asl $06
	asl $06
	asl $06
	nop
	ldx #$00
	;
	jsr raster_call_bot
	;
	jmp main
	;
set_colors
	inc pos_01+1
pos_01	ldx #0
	lda sine,x
	tax
call01	jsr $0000
	inc pos_02+1
pos_02	ldx #2
	lda sine,x
	tax
call02	jsr $0000
	inc pos_03+1
pos_03	ldx #4
	lda sine,x
	tax
call03	jsr $0000
	inc pos_04+1
pos_04	ldx #6
	lda sine,x
	tax
call04	jsr $0000
	inc pos_05+1
pos_05	ldx #8
	lda sine,x
	tax
call05	jsr $0000
	inc pos_06+1
pos_06	ldx #10
	lda sine,x
	tax
call06	jsr $0000
	inc pos_07+1
pos_07	ldx #12
	lda sine,x
	tax
call07	jsr $0000
	inc pos_08+1
pos_08	ldx #14
	lda sine,x
	tax
call08	jsr $0000
	inc pos_09+1
pos_09	ldx #16
	lda sine,x
	tax
call09	jsr $0000
	inc pos_10+1
pos_10	ldx #18
	lda sine,x
	tax
call10	jsr $0000
	inc pos_11+1
pos_11	ldx #20
	lda sine,x
	tax
call11	jsr $0000
	inc pos_12+1
pos_12	ldx #22
	lda sine,x
	tax
call12	jsr $0000
	inc pos_13+1
pos_13	ldx #24
	lda sine,x
	tax
call13	jsr $0000
	inc pos_14+1
pos_14	ldx #26
	lda sine,x
	tax
call14	jsr $0000
	inc pos_15+1
pos_15	ldx #28
	lda sine,x
	tax
call15	jsr $0000
	inc pos_16+1
pos_16	ldx #30
	lda sine,x
	tax
call16	jsr $0000
	;
	rts
	;
	; ---
	;
codegen1
	ldy #$00
	;
	lda height
	sta rows
	;
cg0	lda #$A0	; LDY #$00
	jsr putbyte
	lda #$00
	jsr putbyte
	;
	ldx #15
	;
cg1	lda #$A9	; LDA #$00
	jsr putbyte
	lda #$00
	jsr putbyte
	lda #$2C;8D	; STA $FF19
	jsr putbyte
	lda #$19
	jsr putbyte
	lda #$FF
	jsr putbyte
	;
	dex
	bne cg1
	;
	lda #$2C;8C	; STY $FF19
	jsr putbyte
	lda #$19
	jsr putbyte
	lda #$FF
	jsr putbyte
	;
	ldx #4
	;
cg2	lda #$EA	; NOP
	jsr putbyte
	;
	dex
	bne cg2
	;
	lda #$06	; ASL $06
	jsr putbyte
	lda #$06
	jsr putbyte
	;
	dec rows
	bne cg0
	;
	lda #$A9	; LDA #$00
	jsr putbyte
	lda #$00
	jsr putbyte
	lda #$8D	; STA $FF19
	jsr putbyte
	lda #$19
	jsr putbyte
	lda #$FF
	jsr putbyte
	;
	lda #$60	; RTS
	jmp putbyte
	
codegen2
	ldx #$00
	;
cg21	lda #$BD	; LDA $colors,x
	jsr putbyte
	txa
	jsr putbyte
	lda div3,x
	sta lumaddr+1
lumaddr	lda lum
	jsr putbyte
	;
;	lda #$09	; ORA #$00
;	jsr putbyte
;	lda div3,x
;	clc
;	adc #lum & 255
;	sta lumaddr+1
;lumaddr	lda lum
;	jsr putbyte
	;
	lda #$8D	; STA $####
	jsr putbyte
dadr1Lo	lda #$00
	jsr putbyte
dadr1Hi	lda #$00
	jsr putbyte
	;
	lda #$8D	; STA $####
	jsr putbyte
dadr2Lo	lda #$00
	jsr putbyte
dadr2Hi	lda #$00
	jsr putbyte
	;
	; ---
	;
	lda dadr1Lo+1
	clc
	adc #$56
	sta dadr1Lo+1
	lda dadr1Hi+1
	adc #$00
	sta dadr1Hi+1
	;
	; ---
	;
	lda dadr2Lo+1
	sec
	sbc #$56
	sta dadr2Lo+1
	lda dadr2Hi+1
	sbc #$00
	sta dadr2Hi+1
	;
	inx
	cpx height
	bne cg21
	;
	lda #$60	; RTS
	jmp putbyte
	
putbyte
	sta (ptr),y
	lda ptr
	clc
	adc #$01
	sta ptr
	bcc *+4
	inc ptr+1
	rts

	align 256	
lum
	db $00,$00,$00
	
div3
	db 0,1,2
	db 0,1,2
	db 0,1,2
	;
	db 0,1,2
	db 0,1,2
	db 0,1,2
	;
	db 0,1,2
	db 0,1,2
	db 0,1,2
	;
	db 0,1,2
	db 0,1,2
	db 0,1,2
	;
	db 0,1,2
	db 0,1,2
	db 0,1,2

	org $1800
	include "pic_hex.asm"
	
	include "poen.asm"
	
	align 256
OFS = 0
	include "music\!player.asm"
	include "music\!player_data.asm"
	include "music\music.asm"
	
	;db $B,$2,$8,$9,$7,$A	
	align 256
colorsB
	db $0B,$1B,$2B,$3B,$4B,$2B,$3B,$4B,$5B,$6B,$7B,$6B,$5B,$4B,$3B,$2B,$4B,$3B,$2B,$1B
	db $0B,$1B,$2B,$1B,$2B,$3B,$2B,$3B,$4B,$3B,$4B,$5B,$4B,$5B,$6B,$5B
	db $6B,$7B,$6B,$5B,$6B,$5B,$4B,$5B,$4B,$3B,$4B,$3B,$2B,$3B,$2B,$1B
	db $2B,$1B
	db $0B,$1B,$2B,$3B,$1B,$2B,$3B,$4B,$2B,$3B,$4B,$5B,$3B,$4B
	db $5B,$6B,$4B,$5B,$6B,$7B,$7B,$6B,$5B,$4B,$6B,$5B,$4B,$3B,$5B,$4B
	db $3B,$2B,$4B,$3B,$2B,$1B,$4B,$3B,$2B,$1B
	db $0B,$1B,$2B,$1B,$2B,$3B,$2B,$3B,$4B,$3B,$4B,$5B,$4B,$5B,$6B,$5B
	db $6B,$7B,$6B,$5B,$6B,$5B,$4B,$5B,$4B,$3B,$4B,$3B,$2B,$3B,$2B,$1B
	db $2B,$1B
	db $0B,$1B,$2B,$3B,$4B,$2B,$3B,$4B,$5B,$6B,$7B,$6B,$5B,$4B,$3B,$2B,$4B,$3B,$2B,$1B
	db $0B,$1B,$2B,$1B,$2B,$3B,$2B,$3B,$4B,$3B,$4B,$5B,$4B,$5B,$6B,$5B
	db $6B,$7B,$6B,$5B,$6B,$5B,$4B,$5B,$4B,$3B,$4B,$3B,$2B,$3B,$2B,$1B
	db $2B,$1B
	db $0B,$1B,$2B,$3B,$1B,$2B,$3B,$4B,$2B,$3B,$4B,$5B,$3B,$4B
	db $5B,$6B,$4B,$5B,$6B,$7B,$7B,$6B,$5B,$4B,$6B,$5B,$4B,$3B,$5B,$4B
	db $3B,$2B,$4B,$3B,$2B,$1B,$4B,$3B,$2B,$1B
	db $0B,$1B,$2B,$1B,$2B,$3B,$2B,$3B,$4B,$3B,$4B,$5B,$4B,$5B,$6B,$5B
	db $6B,$7B,$6B,$5B,$6B,$5B,$4B,$5B,$4B,$3B,$4B,$3B,$2B,$3B,$2B,$1B
	db $2B,$1B
colors2
	db $02,$12,$22,$32,$42,$22,$32,$42,$52,$62,$72,$62,$52,$42,$32,$22,$42,$32,$22,$12
	db $02,$12,$22,$12,$22,$32,$22,$32,$42,$32,$42,$52,$42,$52,$62,$52
	db $62,$72,$62,$52,$62,$52,$42,$52,$42,$32,$42,$32,$22,$32,$22,$12
	db $22,$12
	db $02,$12,$22,$32,$12,$22,$32,$42,$22,$32,$42,$52,$32,$42
	db $52,$62,$42,$52,$62,$72,$72,$62,$52,$42,$62,$52,$42,$32,$52,$42
	db $32,$22,$42,$32,$22,$12,$42,$32,$22,$12
	db $02,$12,$22,$12,$22,$32,$22,$32,$42,$32,$42,$52,$42,$52,$62,$52
	db $62,$72,$62,$52,$62,$52,$42,$52,$42,$32,$42,$32,$22,$32,$22,$12
	db $22,$12
	db $02,$12,$22,$32,$42,$22,$32,$42,$52,$62,$72,$62,$52,$42,$32,$22,$42,$32,$22,$12
	db $02,$12,$22,$12,$22,$32,$22,$32,$42,$32,$42,$52,$42,$52,$62,$52
	db $62,$72,$62,$52,$62,$52,$42,$52,$42,$32,$42,$32,$22,$32,$22,$12
	db $22,$12
	db $02,$12,$22,$32,$12,$22,$32,$42,$22,$32,$42,$52,$32,$42
	db $52,$62,$42,$52,$62,$72,$72,$62,$52,$42,$62,$52,$42,$32,$52,$42
	db $32,$22,$42,$32,$22,$12,$42,$32,$22,$12
	db $02,$12,$22,$12,$22,$32,$22,$32,$42,$32,$42,$52,$42,$52,$62,$52
	db $62,$72,$62,$52,$62,$52,$42,$52,$42,$32,$42,$32,$22,$32,$22,$12
	db $22,$12
colors8
	db $08,$18,$28,$38,$48,$28,$38,$48,$58,$68,$78,$68,$58,$48,$38,$28,$48,$38,$28,$18
	db $08,$18,$28,$18,$28,$38,$28,$38,$48,$38,$48,$58,$48,$58,$68,$58
	db $68,$78,$68,$58,$68,$58,$48,$58,$48,$38,$48,$38,$28,$38,$28,$18
	db $28,$18
	db $08,$18,$28,$38,$18,$28,$38,$48,$28,$38,$48,$58,$38,$48
	db $58,$68,$48,$58,$68,$78,$78,$68,$58,$48,$68,$58,$48,$38,$58,$48
	db $38,$28,$48,$38,$28,$18,$48,$38,$28,$18
	db $08,$18,$28,$18,$28,$38,$28,$38,$48,$38,$48,$58,$48,$58,$68,$58
	db $68,$78,$68,$58,$68,$58,$48,$58,$48,$38,$48,$38,$28,$38,$28,$18
	db $28,$18
	db $08,$18,$28,$38,$48,$28,$38,$48,$58,$68,$78,$68,$58,$48,$38,$28,$48,$38,$28,$18
	db $08,$18,$28,$18,$28,$38,$28,$38,$48,$38,$48,$58,$48,$58,$68,$58
	db $68,$78,$68,$58,$68,$58,$48,$58,$48,$38,$48,$38,$28,$38,$28,$18
	db $28,$18
	db $08,$18,$28,$38,$18,$28,$38,$48,$28,$38,$48,$58,$38,$48
	db $58,$68,$48,$58,$68,$78,$78,$68,$58,$48,$68,$58,$48,$38,$58,$48
	db $38,$28,$48,$38,$28,$18,$48,$38,$28,$18
	db $08,$18,$28,$18,$28,$38,$28,$38,$48,$38,$48,$58,$48,$58,$68,$58
	db $68,$78,$68,$58,$68,$58,$48,$58,$48,$38,$48,$38,$28,$38,$28,$18
	db $28,$18
colors9
	db $09,$19,$29,$39,$49,$29,$39,$49,$59,$69,$79,$69,$59,$49,$39,$29,$49,$39,$29,$19
	db $09,$19,$29,$19,$29,$39,$29,$39,$49,$39,$49,$59,$49,$59,$69,$59
	db $69,$79,$69,$59,$69,$59,$49,$59,$49,$39,$49,$39,$29,$39,$29,$19
	db $29,$19
	db $09,$19,$29,$39,$19,$29,$39,$49,$29,$39,$49,$59,$39,$49
	db $59,$69,$49,$59,$69,$79,$79,$69,$59,$49,$69,$59,$49,$39,$59,$49
	db $39,$29,$49,$39,$29,$19,$49,$39,$29,$19
	db $09,$19,$29,$19,$29,$39,$29,$39,$49,$39,$49,$59,$49,$59,$69,$59
	db $69,$79,$69,$59,$69,$59,$49,$59,$49,$39,$49,$39,$29,$39,$29,$19
	db $29,$19
	db $09,$19,$29,$39,$49,$29,$39,$49,$59,$69,$79,$69,$59,$49,$39,$29,$49,$39,$29,$19
	db $09,$19,$29,$19,$29,$39,$29,$39,$49,$39,$49,$59,$49,$59,$69,$59
	db $69,$79,$69,$59,$69,$59,$49,$59,$49,$39,$49,$39,$29,$39,$29,$19
	db $29,$19
	db $09,$19,$29,$39,$19,$29,$39,$49,$29,$39,$49,$59,$39,$49
	db $59,$69,$49,$59,$69,$79,$79,$69,$59,$49,$69,$59,$49,$39,$59,$49
	db $39,$29,$49,$39,$29,$19,$49,$39,$29,$19
	db $09,$19,$29,$19,$29,$39,$29,$39,$49,$39,$49,$59,$49,$59,$69,$59
	db $69,$79,$69,$59,$69,$59,$49,$59,$49,$39,$49,$39,$29,$39,$29,$19
	db $29,$19
colors7
	db $07,$17,$27,$37,$47,$27,$37,$47,$57,$67,$77,$67,$57,$47,$37,$27,$47,$37,$27,$17
	db $07,$17,$27,$17,$27,$37,$27,$37,$47,$37,$47,$57,$47,$57,$67,$57
	db $67,$77,$67,$57,$67,$57,$47,$57,$47,$37,$47,$37,$27,$37,$27,$17
	db $27,$17
	db $07,$17,$27,$37,$17,$27,$37,$47,$27,$37,$47,$57,$37,$47
	db $57,$67,$47,$57,$67,$77,$77,$67,$57,$47,$67,$57,$47,$37,$57,$47
	db $37,$27,$47,$37,$27,$17,$47,$37,$27,$17
	db $07,$17,$27,$17,$27,$37,$27,$37,$47,$37,$47,$57,$47,$57,$67,$57
	db $67,$77,$67,$57,$67,$57,$47,$57,$47,$37,$47,$37,$27,$37,$27,$17
	db $27,$17
	db $07,$17,$27,$37,$47,$27,$37,$47,$57,$67,$77,$67,$57,$47,$37,$27,$47,$37,$27,$17
	db $07,$17,$27,$17,$27,$37,$27,$37,$47,$37,$47,$57,$47,$57,$67,$57
	db $67,$77,$67,$57,$67,$57,$47,$57,$47,$37,$47,$37,$27,$37,$27,$17
	db $27,$17
	db $07,$17,$27,$37,$17,$27,$37,$47,$27,$37,$47,$57,$37,$47
	db $57,$67,$47,$57,$67,$77,$77,$67,$57,$47,$67,$57,$47,$37,$57,$47
	db $37,$27,$47,$37,$27,$17,$47,$37,$27,$17
	db $07,$17,$27,$17,$27,$37,$27,$37,$47,$37,$47,$57,$47,$57,$67,$57
	db $67,$77,$67,$57,$67,$57,$47,$57,$47,$37,$47,$37,$27,$37,$27,$17
	db $27,$17
colorsA
	db $0A,$1A,$2A,$3A,$4A,$2A,$3A,$4A,$5A,$6A,$7A,$6A,$5A,$4A,$3A,$2A,$4A,$3A,$2A,$1A
	db $0A,$1A,$2A,$1A,$2A,$3A,$2A,$3A,$4A,$3A,$4A,$5A,$4A,$5A,$6A,$5A
	db $6A,$7A,$6A,$5A,$6A,$5A,$4A,$5A,$4A,$3A,$4A,$3A,$2A,$3A,$2A,$1A
	db $2A,$1A
	db $0A,$1A,$2A,$3A,$1A,$2A,$3A,$4A,$2A,$3A,$4A,$5A,$3A,$4A
	db $5A,$6A,$4A,$5A,$6A,$7A,$7A,$6A,$5A,$4A,$6A,$5A,$4A,$3A,$5A,$4A
	db $3A,$2A,$4A,$3A,$2A,$1A,$4A,$3A,$2A,$1A
	db $0A,$1A,$2A,$1A,$2A,$3A,$2A,$3A,$4A,$3A,$4A,$5A,$4A,$5A,$6A,$5A
	db $6A,$7A,$6A,$5A,$6A,$5A,$4A,$5A,$4A,$3A,$4A,$3A,$2A,$3A,$2A,$1A
	db $2A,$1A
	db $0A,$1A,$2A,$3A,$4A,$2A,$3A,$4A,$5A,$6A,$7A,$6A,$5A,$4A,$3A,$2A,$4A,$3A,$2A,$1A
	db $0A,$1A,$2A,$1A,$2A,$3A,$2A,$3A,$4A,$3A,$4A,$5A,$4A,$5A,$6A,$5A
	db $6A,$7A,$6A,$5A,$6A,$5A,$4A,$5A,$4A,$3A,$4A,$3A,$2A,$3A,$2A,$1A
	db $2A,$1A
	db $0A,$1A,$2A,$3A,$1A,$2A,$3A,$4A,$2A,$3A,$4A,$5A,$3A,$4A
	db $5A,$6A,$4A,$5A,$6A,$7A,$7A,$6A,$5A,$4A,$6A,$5A,$4A,$3A,$5A,$4A
	db $3A,$2A,$4A,$3A,$2A,$1A,$4A,$3A,$2A,$1A
	db $0A,$1A,$2A,$1A,$2A,$3A,$2A,$3A,$4A,$3A,$4A,$5A,$4A,$5A,$6A,$5A
	db $6A,$7A,$6A,$5A,$6A,$5A,$4A,$5A,$4A,$3A,$4A,$3A,$2A,$3A,$2A,$1A
	db $2A,$1A
sine
;128,80
;	db $50,$54,$58,$5C,$60,$63,$67,$6B,$6F,$72,$76,$79,$7C,$80,$83,$86
;	db $89,$8B,$8E,$90,$93,$95,$97,$98,$9A,$9B,$9D,$9E,$9E,$9F,$A0,$A0
;	db $A0,$A0,$A0,$9F,$9E,$9E,$9D,$9B,$9A,$98,$97,$95,$93,$90,$8E,$8B
;	db $89,$86,$83,$80,$7C,$79,$76,$72,$6F,$6B,$67,$63,$60,$5C,$58,$54
;	db $50,$4C,$48,$44,$40,$3D,$39,$35,$31,$2E,$2A,$27,$24,$20,$1D,$1A
;	db $17,$15,$12,$10,$0D,$0B,$09,$08,$06,$05,$03,$02,$02,$01,$00,$00
;	db $00,$00,$00,$01,$02,$02,$03,$05,$06,$08,$09,$0B,$0D,$10,$12,$15
;	db $17,$1A,$1D,$20,$24,$27,$2A,$2E,$31,$35,$39,$3D,$40,$44,$48,$4C
;	db $50,$54,$58,$5C,$60,$63,$67,$6B,$6F,$72,$76,$79,$7C,$80,$83,$86
;	db $89,$8B,$8E,$90,$93,$95,$97,$98,$9A,$9B,$9D,$9E,$9E,$9F,$A0,$A0
;	db $A0,$A0,$A0,$9F,$9E,$9E,$9D,$9B,$9A,$98,$97,$95,$93,$90,$8E,$8B
;	db $89,$86,$83,$80,$7C,$79,$76,$72,$6F,$6B,$67,$63,$60,$5C,$58,$54
;	db $50,$4C,$48,$44,$40,$3D,$39,$35,$31,$2E,$2A,$27,$24,$20,$1D,$1A
;	db $17,$15,$12,$10,$0D,$0B,$09,$08,$06,$05,$03,$02,$02,$01,$00,$00
;	db $00,$00,$00,$01,$02,$02,$03,$05,$06,$08,$09,$0B,$0D,$10,$12,$15
;	db $17,$1A,$1D,$20,$24,$27,$2A,$2E,$31,$35,$39,$3D,$40,$44,$48,$4C

	db $3C,$3F,$42,$45,$48,$4B,$4D,$50,$53,$56,$58,$5B,$5D,$60,$62,$64
	db $66,$68,$6A,$6C,$6E,$6F,$71,$72,$73,$74,$75,$76,$77,$77,$78,$78
	db $78,$78,$78,$77,$77,$76,$75,$74,$73,$72,$71,$6F,$6E,$6C,$6A,$68
	db $66,$64,$62,$60,$5D,$5B,$58,$56,$53,$50,$4D,$4B,$48,$45,$42,$3F
	db $3C,$39,$36,$33,$30,$2D,$2B,$28,$25,$22,$20,$1D,$1B,$18,$16,$14
	db $12,$10,$0E,$0C,$0A,$09,$07,$06,$05,$04,$03,$02,$01,$01,$00,$00
	db $00,$00,$00,$01,$01,$02,$03,$04,$05,$06,$07,$09,$0A,$0C,$0E,$10
	db $12,$14,$16,$18,$1B,$1D,$20,$22,$25,$28,$2B,$2D,$30,$33,$36,$39
	db $3C,$3F,$42,$45,$48,$4B,$4D,$50,$53,$56,$58,$5B,$5D,$60,$62,$64
	db $66,$68,$6A,$6C,$6E,$6F,$71,$72,$73,$74,$75,$76,$77,$77,$78,$78
	db $78,$78,$78,$77,$77,$76,$75,$74,$73,$72,$71,$6F,$6E,$6C,$6A,$68
	db $66,$64,$62,$60,$5D,$5B,$58,$56,$53,$50,$4D,$4B,$48,$45,$42,$3F
	db $3C,$39,$36,$33,$30,$2D,$2B,$28,$25,$22,$20,$1D,$1B,$18,$16,$14
	db $12,$10,$0E,$0C,$0A,$09,$07,$06,$05,$04,$03,$02,$01,$01,$00,$00
	db $00,$00,$00,$01,$01,$02,$03,$04,$05,$06,$07,$09,$0A,$0C,$0E,$10
	db $12,$14,$16,$18,$1B,$1D,$20,$22,$25,$28,$2B,$2D,$30,$33,$36,$39
	
fx_data
	dw 1,fx_pause
	;
	dw 5*8,fx_bot_col01_on
	dw 5*8,fx_bot_col02_on
	dw 5*8,fx_bot_col03_on
	dw 5*8,fx_bot_col04_on
	dw 5*8,fx_bot_col05_on
	dw 5*8,fx_bot_col06_on
	dw 5*8,fx_bot_col07_on
	dw 5*8,fx_bot_col08_on
	dw 5*8,fx_bot_col09_on
	dw 5*8,fx_bot_col10_on
	dw 5*8,fx_bot_col11_on
	dw 5*8,fx_bot_col12_on
	dw 5*8,fx_bot_col13_on
	dw 5*8,fx_bot_col14_on
	dw 5*8,fx_bot_col15_on
	dw 5*8,fx_bot_col16_on
	;
	dw 5*8,fx_top_col01_on
	dw 5*8,fx_top_col02_on
	dw 5*8,fx_top_col03_on
	dw 5*8,fx_top_col04_on
	dw 5*8,fx_top_col05_on
	dw 5*8,fx_top_col06_on
	dw 5*8,fx_top_col07_on
	dw 5*8,fx_top_col08_on
	dw 5*8,fx_top_col09_on
	dw 5*8,fx_top_col10_on
	dw 5*8,fx_top_col11_on
	dw 5*8,fx_top_col12_on
	dw 5*8,fx_top_col13_on
	dw 5*8,fx_top_col14_on
	dw 5*8,fx_top_col15_on
	dw 5*8,fx_top_col16_on
	;
fx_data1
	dw 1,fx_pause
	;
	dw $1,fx_set_merry
	dw $3A,fx_copy_bits
	dw $1,fx_set_christmas
	dw $5B,fx_copy_bits
	dw $1,fx_set_to
	dw $12,fx_copy_bits
	dw $1,fx_set_everyone
	dw $50,fx_copy_bits
	;
	dw 100,fx_pause
	;
	dw $1,fx_set_merry
	dw $3A,fx_clear_bits
	dw $1,fx_set_christmas
	dw $5B,fx_clear_bits
	dw $1,fx_set_to
	dw $12,fx_clear_bits
	dw $1,fx_set_everyone
	dw $50,fx_clear_bits
	;
	dw $1,fx_set_boldog
	dw $54,fx_copy_bits
	dw $1,fx_set_karacsonyt
	dw $58,fx_copy_bits
	;
	dw 100,fx_pause
	;
	dw $1,fx_set_boldog
	dw $54,fx_clear_bits
	dw $1,fx_set_karacsonyt
	dw $58,fx_clear_bits
	;
	dw $1,fx_set_frohliche
	dw $59,fx_copy_bits
	dw $1,fx_set_weihnachten
	dw $60,fx_copy_bits
	;
	dw 100,fx_pause
	;
	dw $1,fx_set_frohliche
	dw $59,fx_clear_bits
	dw $1,fx_set_weihnachten
	dw $60,fx_clear_bits
	;
	dw $1,fx_set_buon
	dw $3F,fx_copy_bits
	dw $1,fx_set_natale
	dw $59,fx_copy_bits
	;
	dw 100,fx_pause
	;
	dw $1,fx_set_buon
	dw $3F,fx_clear_bits
	dw $1,fx_set_natale
	dw $59,fx_clear_bits
	;
	dw 10,fx_pause
	;
	dw $1,fx_switch_to_joke
	;
	dw 400,fx_pause        
	;
	dw $1,fx_switch_to_tree
	;
	dw $1,fx_restart_2
	
fx
	lda fx_cnt
	ora fx_cnt+1
	beq fx_next
	;
	lda fx_cnt
	sec
	sbc #$01
	sta fx_cnt
	lda fx_cnt+1
	sbc #$00
	sta fx_cnt+1
	;
fx_call	jmp $0000
	;
fx_next
	;jmp *
	lda fx_ptr
	clc
	adc #$04
	sta fx_ptr
	lda fx_ptr+1
	adc #$00
	sta fx_ptr+1
	;
	ldy #$00
	lda (fx_ptr),y
	sta fx_cnt
	;
	iny
	lda (fx_ptr),y
	sta fx_cnt+1
	;
	iny
	lda (fx_ptr),y
	sta fx_call+1
	;
	iny
	lda (fx_ptr),y
	sta fx_call+2
	;
	rts
	
fx_pause
	rts
	
fx_restart_2
	lda #(fx_data1-4) & 255
	sta fx_ptr
	lda #(fx_data1-4) >> 8
	sta fx_ptr+1
	lda #$00
	sta fx_cnt
	sta fx_cnt+1
	;
	rts
	
fx_set_merry
	lda #en_merry & 255
	sta gfx_ptr
	lda #en_merry >> 8
	sta gfx_ptr+1
	;
	ldx #$78
	ldy #$25
	lda #$03
	jmp fx_set_bitmap_ptr
	;
fx_set_christmas
	lda #en_christmas & 255
	sta gfx_ptr
	lda #en_christmas >> 8
	sta gfx_ptr+1
	;
	ldx #$78
	ldy #$2A
	lda #$02
	jmp fx_set_bitmap_ptr
	;
fx_set_to
	lda #en_to & 255
	sta gfx_ptr
	lda #en_to >> 8
	sta gfx_ptr+1
	;
	ldx #$88
	ldy #$2F
	lda #$02
	bne fx_set_bitmap_ptr
	;
fx_set_everyone
	lda #en_everyone & 255
	sta gfx_ptr
	lda #en_everyone >> 8
	sta gfx_ptr+1
	;
	ldx #$90
	ldy #$34
	lda #$03
	bne fx_set_bitmap_ptr
	;
fx_set_boldog
	lda #hu_boldog & 255
	sta gfx_ptr
	lda #hu_boldog >> 8
	sta gfx_ptr+1
	;
	ldx #$80
	ldy #$2A
	lda #$05
	bne fx_set_bitmap_ptr
	;
fx_set_karacsonyt
	lda #hu_karacsonyt & 255
	sta gfx_ptr
	lda #hu_karacsonyt >> 8
	sta gfx_ptr+1
	;
	ldx #$08
	ldy #$32
	lda #$03
	bne fx_set_bitmap_ptr
	;
fx_set_frohliche
	lda #de_frohliche & 255
	sta gfx_ptr
	lda #de_frohliche >> 8
	sta gfx_ptr+1
	;
	ldx #$C8
	ldy #$2B
	lda #$03
	bne fx_set_bitmap_ptr
	;
fx_set_weihnachten
	lda #de_weihnachten & 255
	sta gfx_ptr
	lda #de_weihnachten >> 8
	sta gfx_ptr+1
	;
	ldx #$00
	ldy #$32
	lda #$02
	bne fx_set_bitmap_ptr
	;
fx_set_buon
	lda #it_buon & 255
	sta gfx_ptr
	lda #it_buon >> 8
	sta gfx_ptr+1
	;
	ldx #$48
	ldy #$29
	lda #$04
	bne fx_set_bitmap_ptr
	;
fx_set_natale
	lda #it_natale & 255
	sta gfx_ptr
	lda #it_natale >> 8
	sta gfx_ptr+1
	;
	ldx #$08
	ldy #$32
	lda #$04
	bne fx_set_bitmap_ptr
	;
fx_set_bitmap_ptr
	stx bitmap_ptr
	sty bitmap_ptr+1
	sta clear_height+1
	sta copy_height+1
	;
	lda #$00
	sta bit_cnt
	;
	rts
	
and_bits
	db $3F,$0F,$03,$00
or_bits
	db $40,$50,$54,$55
	
and2_bits
	db $C0,$F0,$FC,$FF
or2_bits
	db $15,$05,$01,$00
	
fx_clear_bits
	ldx bit_cnt
	lda and_bits,x
	sta and1+1
	lda or_bits,x
	sta or1+1
	;
	lda bitmap_ptr
	pha
	lda bitmap_ptr+1
	pha
	;
clear_height
	ldx #$00
fxcb2	ldy #$07
fxcb1	lda (bitmap_ptr),y
and1	and #$00
or1	ora #$00
	sta (bitmap_ptr),y
	dey
	bpl fxcb1
	;
	lda bitmap_ptr
	clc
	adc #$40
	sta bitmap_ptr
	lda bitmap_ptr+1
	adc #$01
	sta bitmap_ptr+1
	;
	dex
	bpl fxcb2
	;
	pla
	sta bitmap_ptr+1
	pla
	sta bitmap_ptr
	;
	ldx bit_cnt
	inx
	cpx #$04
	bne fxcb3
	;
	lda bitmap_ptr
	clc
	adc #$08
	sta bitmap_ptr
	lda bitmap_ptr+1
	adc #$00
	sta bitmap_ptr+1
	;
	ldx #$00
fxcb3 	stx bit_cnt
	;
	rts
	
fx_copy_bits
	ldx bit_cnt
	lda and2_bits,x
	sta and2+1
	lda or2_bits,x
	sta or2+1
	;
	lda gfx_ptr
	pha
	lda gfx_ptr+1
	pha
	;
	lda bitmap_ptr
	pha
	lda bitmap_ptr+1
	pha
	;
copy_height
	ldx #$00
fxcb5	ldy #$07
fxcb4	lda (gfx_ptr),y
and2	and #$00
or2	ora #$00
	sta (bitmap_ptr),y
	dey
	bpl fxcb4
	;
	lda bitmap_ptr
	clc
	adc #$40
	sta bitmap_ptr
	lda bitmap_ptr+1
	adc #$01
	sta bitmap_ptr+1
	;
	lda gfx_ptr
	clc
	adc #$08
	sta gfx_ptr
	lda gfx_ptr+1
	adc #$00
	sta gfx_ptr+1
	;
	dex
	bpl fxcb5
	;
	pla
	sta bitmap_ptr+1
	pla
	sta bitmap_ptr
	;
	ldx bit_cnt
	inx
	cpx #$04
	bne fxcb6
	;
	lda bitmap_ptr
	clc
	adc #$08
	sta bitmap_ptr
	lda bitmap_ptr+1
	adc #$00
	sta bitmap_ptr+1
	;
	pla
	pla
	ldx #$00
	beq fxcb7
	;
fxcb6	pla
	sta gfx_ptr+1
	pla
	sta gfx_ptr
fxcb7	stx bit_cnt
	;
	rts
	
fx_switch_to_joke
	lda #$08
	sta gfx1+1
	lda #$10
	sta gfx2+1
	lda #$60
	sta gfx3+1
	rts
	
fx_switch_to_tree
	lda #$18
	sta gfx1+1
	lda #$08
	sta gfx2+1
	lda #$18
	sta gfx3+1
	rts
	
fx_bot_col01_on
	ldy #$04
	lda #$8D
	jsr fx_put_bot_col
	;
	ldy #$09
	lda #$8E
	jmp fx_put_bot_col
	
fx_bot_col02_on
	ldy #$09
	lda #$8D
	jsr fx_put_bot_col
	;
	ldy #$0E
	lda #$8E
	jmp fx_put_bot_col
	
fx_bot_col03_on
	ldy #$0E
	lda #$8D
	jsr fx_put_bot_col
	;
	ldy #$13
	lda #$8E
	jmp fx_put_bot_col
	
fx_bot_col04_on
	ldy #$13
	lda #$8D
	jsr fx_put_bot_col
	;
	ldy #$18
	lda #$8E
	jmp fx_put_bot_col
	
fx_bot_col05_on
	ldy #$18
	lda #$8D
	jsr fx_put_bot_col
	;
	ldy #$1D
	lda #$8E
	jmp fx_put_bot_col
	
fx_bot_col06_on
	ldy #$1D
	lda #$8D
	jsr fx_put_bot_col
	;
	ldy #$22
	lda #$8E
	jmp fx_put_bot_col
	
fx_bot_col07_on
	ldy #$22
	lda #$8D
	jsr fx_put_bot_col
	;
	ldy #$27
	lda #$8E
	jmp fx_put_bot_col
	
fx_bot_col08_on
	ldy #$27
	lda #$8D
	jsr fx_put_bot_col
	;
	ldy #$2C
	lda #$8E
	jmp fx_put_bot_col
	
fx_bot_col09_on
	ldy #$2C
	lda #$8D
	jsr fx_put_bot_col
	;
	ldy #$31
	lda #$8E
	jmp fx_put_bot_col
	
fx_bot_col10_on
	ldy #$31
	lda #$8D
	jsr fx_put_bot_col
	;
	ldy #$36
	lda #$8E
	jmp fx_put_bot_col
	
fx_bot_col11_on
	ldy #$36
	lda #$8D
	jsr fx_put_bot_col
	;
	ldy #$3B
	lda #$8E
	jmp fx_put_bot_col
	
fx_bot_col12_on
	ldy #$3B
	lda #$8D
	jsr fx_put_bot_col
	;
	ldy #$40
	lda #$8E
	jmp fx_put_bot_col
	
fx_bot_col13_on
	ldy #$40
	lda #$8D
	jsr fx_put_bot_col
	;
	ldy #$45
	lda #$8E
	jmp fx_put_bot_col
	
fx_bot_col14_on
	ldy #$45
	lda #$8D
	jsr fx_put_bot_col
	;
	ldy #$4A
	lda #$8E
	jmp fx_put_bot_col
	
fx_bot_col15_on
	ldy #$4A
	lda #$8D
	jsr fx_put_bot_col
	;
	ldy #$4D
	lda #$8E
	jmp fx_put_bot_col
	
fx_bot_col16_on
	ldy #$4D
	lda #$8C
	jmp fx_put_bot_col
	
fx_put_bot_col
	sta fx_put1+1
	;
	ldx fx_cnt
	cpx height
	bcs fx_put3
	;
	lda #raster_call_bot & 255
	clc
	adc mul56Lo,x
	sta ptr
	lda #raster_call_bot >> 8
	adc mul56Hi,x
	sta ptr+1
	;
fx_put1	lda #$00
	sta (ptr),y
	;
fx_put3	rts
	
fx_top_col01_on
	ldy #$04
	lda #$8D
	jsr fx_put_top_col
	;
	ldy #$09
	lda #$8E
	jmp fx_put_top_col
	
fx_top_col02_on
	ldy #$09
	lda #$8D
	jsr fx_put_top_col
	;
	ldy #$0E
	lda #$8E
	jmp fx_put_top_col
	
fx_top_col03_on
	ldy #$0E
	lda #$8D
	jsr fx_put_top_col
	;
	ldy #$13
	lda #$8E
	jmp fx_put_top_col
	
fx_top_col04_on
	ldy #$13
	lda #$8D
	jsr fx_put_top_col
	;
	ldy #$18
	lda #$8E
	jmp fx_put_top_col
	
fx_top_col05_on
	ldy #$18
	lda #$8D
	jsr fx_put_top_col
	;
	ldy #$1D
	lda #$8E
	jmp fx_put_top_col
	
fx_top_col06_on
	ldy #$1D
	lda #$8D
	jsr fx_put_top_col
	;
	ldy #$22
	lda #$8E
	jmp fx_put_top_col
	
fx_top_col07_on
	ldy #$22
	lda #$8D
	jsr fx_put_top_col
	;
	ldy #$27
	lda #$8E
	jmp fx_put_top_col
	
fx_top_col08_on
	ldy #$27
	lda #$8D
	jsr fx_put_top_col
	;
	ldy #$2C
	lda #$8E
	jmp fx_put_top_col
	
fx_top_col09_on
	ldy #$2C
	lda #$8D
	jsr fx_put_top_col
	;
	ldy #$31
	lda #$8E
	jmp fx_put_top_col
	
fx_top_col10_on
	ldy #$31
	lda #$8D
	jsr fx_put_top_col
	;
	ldy #$36
	lda #$8E
	jmp fx_put_top_col
	
fx_top_col11_on
	ldy #$36
	lda #$8D
	jsr fx_put_top_col
	;
	ldy #$3B
	lda #$8E
	jmp fx_put_top_col
	
fx_top_col12_on
	ldy #$3B
	lda #$8D
	jsr fx_put_top_col
	;
	ldy #$40
	lda #$8E
	jmp fx_put_top_col
	
fx_top_col13_on
	ldy #$40
	lda #$8D
	jsr fx_put_top_col
	;
	ldy #$45
	lda #$8E
	jmp fx_put_top_col
	
fx_top_col14_on
	ldy #$45
	lda #$8D
	jsr fx_put_top_col
	;
	ldy #$4A
	lda #$8E
	jmp fx_put_top_col
	
fx_top_col15_on
	ldy #$4A
	lda #$8D
	jsr fx_put_top_col
	;
	ldy #$4D
	lda #$8E
	jmp fx_put_top_col
	
fx_top_col16_on
	ldy #$4D
	lda #$8C
	jmp fx_put_top_col
	
fx_put_top_col
	sta fx_put2+1
	;
	ldx fx_cnt
	cpx height
	bcs fx_put4
	;
	lda #raster_call_top & 255
	clc
	adc mul56Lo,x
	sta ptr
	lda #raster_call_top >> 8
	adc mul56Hi,x
	sta ptr+1
	;
fx_put2	lda #$00
	sta (ptr),y
	;
fx_put4	rts
	
mul56Lo	db ($56*0) & 255
	db ($56*1) & 255
	db ($56*2) & 255
	db ($56*3) & 255
	db ($56*4) & 255
	db ($56*5) & 255
	db ($56*6) & 255
	db ($56*7) & 255
	db ($56*8) & 255
	db ($56*9) & 255
	;
	db ($56*10) & 255
	db ($56*11) & 255
	db ($56*12) & 255
	db ($56*13) & 255
	db ($56*14) & 255
	db ($56*15) & 255
	db ($56*16) & 255
	db ($56*17) & 255
	db ($56*18) & 255
	db ($56*19) & 255
	;
	db ($56*20) & 255
	db ($56*21) & 255
	db ($56*22) & 255
	db ($56*23) & 255
	db ($56*24) & 255
	db ($56*25) & 255
	db ($56*26) & 255
	db ($56*27) & 255
	db ($56*28) & 255
	db ($56*29) & 255
	;
	db ($56*30) & 255
	db ($56*31) & 255
	db ($56*32) & 255
	db ($56*33) & 255
	db ($56*34) & 255
	db ($56*35) & 255
	db ($56*36) & 255
	db ($56*37) & 255
	db ($56*38) & 255
	db ($56*39) & 255
	;
	db ($56*40) & 255
	db ($56*41) & 255
	db ($56*42) & 255
	db ($56*43) & 255
	db ($56*44) & 255
	db ($56*45) & 255
	db ($56*46) & 255
	db ($56*47) & 255
	db ($56*48) & 255
	db ($56*49) & 255
	
mul56Hi	db ($56*0) >> 8
	db ($56*1) >> 8
	db ($56*2) >> 8
	db ($56*3) >> 8
	db ($56*4) >> 8
	db ($56*5) >> 8
	db ($56*6) >> 8
	db ($56*7) >> 8
	db ($56*8) >> 8
	db ($56*9) >> 8
	;
	db ($56*10) >> 8
	db ($56*11) >> 8
	db ($56*12) >> 8
	db ($56*13) >> 8
	db ($56*14) >> 8
	db ($56*15) >> 8
	db ($56*16) >> 8
	db ($56*17) >> 8
	db ($56*18) >> 8
	db ($56*19) >> 8
	;
	db ($56*20) >> 8
	db ($56*21) >> 8
	db ($56*22) >> 8
	db ($56*23) >> 8
	db ($56*24) >> 8
	db ($56*25) >> 8
	db ($56*26) >> 8
	db ($56*27) >> 8
	db ($56*28) >> 8
	db ($56*29) >> 8
	;
	db ($56*30) >> 8
	db ($56*31) >> 8
	db ($56*32) >> 8
	db ($56*33) >> 8
	db ($56*34) >> 8
	db ($56*35) >> 8
	db ($56*36) >> 8
	db ($56*37) >> 8
	db ($56*38) >> 8
	db ($56*39) >> 8
	;
	db ($56*40) >> 8
	db ($56*41) >> 8
	db ($56*42) >> 8
	db ($56*43) >> 8
	db ($56*44) >> 8
	db ($56*45) >> 8
	db ($56*46) >> 8
	db ($56*47) >> 8
	db ($56*48) >> 8
	db ($56*49) >> 8
	
en_merry
	include "en_merry.asm"
en_christmas
	include "en_christmas.asm"
en_to
	include "en_to.asm"
en_everyone
	include "en_everyone.asm"

hu_boldog
	include "hu_boldog.asm"
hu_karacsonyt
	include "hu_karacsonyt.asm"
	
de_frohliche
	include "de_frohliche.asm"
de_weihnachten
	include "de_weihnachten.asm"
	
it_buon
	include "it_buon.asm"
it_natale
	include "it_natale.asm"

;eod